Object.defineProperty(exports, "__esModule", { value: true });
var view_1 = require("tns-core-modules/ui/core/view");
var stack_layout_1 = require("tns-core-modules/ui/layouts/stack-layout");
var proxy_view_container_1 = require("tns-core-modules/ui/proxy-view-container");
var tns_wear_os_listview_holder_1 = require("./tns-wear-os-listview-holder");
var wear_os_listview_base_1 = require("./wear-os-listview-base");
function ensureWearOsListViewAdapterClass() {
    if (exports.TNS_WearOsListViewAdapterClass) {
        return;
    }
    var TNS_WearOsListViewAdapter = (function (_super) {
        __extends(TNS_WearOsListViewAdapter, _super);
        function TNS_WearOsListViewAdapter(owner) {
            var _this = _super.call(this) || this;
            _this.owner = owner;
            return global.__native(_this);
        }
        TNS_WearOsListViewAdapter.prototype.onCreateViewHolder = function (parent, viewType) {
            var owner = this.owner ? this.owner.get() : null;
            if (!owner) {
                return null;
            }
            var template = owner._itemTemplatesInternal[viewType];
            var view = template.createView() || owner._getDefaultItemContent(viewType);
            if (view instanceof view_1.View && !(view instanceof proxy_view_container_1.ProxyViewContainer)) {
                owner._addView(view);
            }
            else {
                var sp = new stack_layout_1.StackLayout();
                sp.addChild(view);
                owner._addView(sp);
            }
            owner._realizedItems.set(view.nativeView, view);
            return new tns_wear_os_listview_holder_1.TNS_WearOsListViewHolder(new WeakRef(view), new WeakRef(owner));
        };
        TNS_WearOsListViewAdapter.prototype.onBindViewHolder = function (holder, index) {
            var owner = this.owner ? this.owner.get() : null;
            if (owner) {
                var args = {
                    eventName: wear_os_listview_base_1.ITEMLOADING,
                    object: owner,
                    android: holder,
                    ios: undefined,
                    index: index,
                    view: holder.view
                };
                owner.notify(args);
                if (owner.layoutType === wear_os_listview_base_1.LayoutTypeOptions.STAGGERED) {
                    var random = void 0;
                    var max = wear_os_listview_base_1.layout.toDeviceIndependentPixels(owner._effectiveItemHeight);
                    var min = wear_os_listview_base_1.layout.toDeviceIndependentPixels(owner._effectiveItemHeight) *
                        (1 / 3);
                    if (min && max) {
                        if (owner._staggeredMap && owner._staggeredMap.has(index)) {
                            random = owner._staggeredMap.get(index);
                        }
                        else {
                            random =
                                owner._random.nextInt(max - min + min) +
                                    min;
                            if (!owner._staggeredMap) {
                                owner._staggeredMap = new Map();
                            }
                            owner._staggeredMap.set(index, random);
                        }
                        holder.view.height = random;
                    }
                }
                else {
                    if (owner._itemHeight) {
                        holder.view.height = wear_os_listview_base_1.layout.toDeviceIndependentPixels(owner._effectiveItemHeight);
                    }
                    if (owner._itemWidth) {
                        holder.view.width = wear_os_listview_base_1.layout.toDeviceIndependentPixels(owner._effectiveItemWidth);
                    }
                }
                owner._prepareItem(holder.view, index);
            }
        };
        TNS_WearOsListViewAdapter.prototype.getItemId = function (i) {
            var owner = this.owner ? this.owner.get() : null;
            var id = i;
            if (owner && owner.items) {
                var item = owner.items.getItem
                    ? owner.items.getItem(i)
                    : owner.items[i];
                if (item) {
                    id = owner.itemIdGenerator(item, i, owner.items);
                }
            }
            return long(id);
        };
        TNS_WearOsListViewAdapter.prototype.getItemCount = function () {
            var owner = this.owner ? this.owner.get() : null;
            return owner && owner.items && owner.items.length
                ? owner.items.length
                : 0;
        };
        TNS_WearOsListViewAdapter.prototype.getItemViewType = function (index) {
            var owner = this.owner ? this.owner.get() : null;
            if (owner) {
                var template = owner._getItemTemplate(index);
                return owner._itemTemplatesInternal.indexOf(template);
            }
            return 0;
        };
        TNS_WearOsListViewAdapter = __decorate([
            JavaProxy('com.nativescript.TNS_WearOsListViewAdapter')
        ], TNS_WearOsListViewAdapter);
        return TNS_WearOsListViewAdapter;
    }(android.support.v7.widget.RecyclerView
        .Adapter));
    exports.TNS_WearOsListViewAdapterClass = TNS_WearOsListViewAdapter;
}
exports.ensureWearOsListViewAdapterClass = ensureWearOsListViewAdapterClass;
