Object.defineProperty(exports, "__esModule", { value: true });
var wear_os_listview_base_1 = require("./wear-os-listview-base");
var TNS_WearOsListViewHolder = (function (_super) {
    __extends(TNS_WearOsListViewHolder, _super);
    function TNS_WearOsListViewHolder(owner, list) {
        var _this = _super.call(this, owner.get().nativeViewProtected) || this;
        _this.owner = owner;
        _this.list = list;
        _this._selected = false;
        var that = global.__native(_this);
        owner.get().nativeViewProtected.setOnClickListener(that);
        owner.get().nativeViewProtected.setOnLongClickListener(that);
        return that;
    }
    TNS_WearOsListViewHolder.prototype.isSelected = function () {
        return this._selected;
    };
    TNS_WearOsListViewHolder.prototype.setIsSelected = function (selected) {
        this._selected = selected;
    };
    Object.defineProperty(TNS_WearOsListViewHolder.prototype, "view", {
        get: function () {
            return this.owner ? this.owner.get() : null;
        },
        enumerable: true,
        configurable: true
    });
    TNS_WearOsListViewHolder.prototype.onClick = function (v) {
        var listView = this.list.get();
        var index = this.getAdapterPosition();
        listView.notify({
            eventName: wear_os_listview_base_1.ITEMTAP,
            object: listView,
            index: index,
            view: this.view,
            android: v,
            ios: undefined
        });
        if (listView.selectionBehavior !== 'Press')
            return;
        var items = listView.items;
        var item = items.getItem ? items.getItem(index) : items[index];
        if (listView.multipleSelection) {
            if (this.isSelected()) {
                listView._itemsSelected = listView._itemsSelected.filter(function (selected) {
                    if (selected !== item) {
                        return selected;
                    }
                });
                this.setIsSelected(false);
                listView.notify({
                    eventName: wear_os_listview_base_1.ITEMDESELECTED,
                    object: listView,
                    index: index,
                    view: this.view,
                    android: v,
                    ios: undefined
                });
            }
            else {
                this.setIsSelected(true);
                listView._itemsSelected.push(item);
                listView.notify({
                    eventName: wear_os_listview_base_1.ITEMSELECTED,
                    object: listView,
                    index: index,
                    view: this.view,
                    android: v,
                    ios: undefined
                });
            }
        }
        else {
            if (this.isSelected()) {
                listView._itemsSelected.pop();
                this.setIsSelected(false);
                listView.notify({
                    eventName: wear_os_listview_base_1.ITEMDESELECTED,
                    object: listView,
                    index: index,
                    view: this.view,
                    android: v,
                    ios: undefined
                });
            }
            else {
                this.setIsSelected(true);
                listView._itemsSelected.push(item);
                listView.notify({
                    eventName: wear_os_listview_base_1.ITEMSELECTED,
                    object: listView,
                    index: index,
                    view: this.view,
                    android: v,
                    ios: undefined
                });
            }
        }
    };
    TNS_WearOsListViewHolder.prototype.onLongClick = function (v) {
        var listView = this.list.get();
        var index = this.getAdapterPosition();
        if (listView.selectionBehavior === 'LongPress') {
            var items = listView.items;
            var item_1 = items.getItem ? items.getItem(index) : items[index];
            if (listView.multipleSelection) {
                if (this.isSelected()) {
                    listView._itemsSelected = listView._itemsSelected.filter(function (selected) {
                        if (selected !== item_1) {
                            return selected;
                        }
                    });
                    this.setIsSelected(false);
                    listView.notify({
                        eventName: wear_os_listview_base_1.ITEMDESELECTED,
                        object: listView,
                        index: index,
                        view: this.view,
                        android: v,
                        ios: undefined
                    });
                }
                else {
                    this.setIsSelected(true);
                    listView._itemsSelected.push(item_1);
                    listView.notify({
                        eventName: wear_os_listview_base_1.ITEMSELECTED,
                        object: listView,
                        index: index,
                        view: this.view,
                        android: v,
                        ios: undefined
                    });
                }
            }
            else {
                if (this.isSelected()) {
                    listView._itemsSelected.pop();
                    this.setIsSelected(false);
                    listView.notify({
                        eventName: wear_os_listview_base_1.ITEMDESELECTED,
                        object: listView,
                        index: index,
                        view: this.view,
                        android: v,
                        ios: undefined
                    });
                }
                else {
                    this.setIsSelected(true);
                    listView._itemsSelected.push(item_1);
                    listView.notify({
                        eventName: wear_os_listview_base_1.ITEMSELECTED,
                        object: listView,
                        index: index,
                        view: this.view,
                        android: v,
                        ios: undefined
                    });
                }
            }
        }
        return true;
    };
    TNS_WearOsListViewHolder = __decorate([
        Interfaces([
            android.view.View.OnClickListener,
            android.view.View.OnLongClickListener
        ])
    ], TNS_WearOsListViewHolder);
    return TNS_WearOsListViewHolder;
}(android.support.v7.widget.RecyclerView.ViewHolder));
exports.TNS_WearOsListViewHolder = TNS_WearOsListViewHolder;
